#!/usr/bin/perl

use warnings;
use strict;

use AnyEvent;
use AnyEvent::Handle;
use AnyEvent::Util;

my $q = AnyEvent->condvar;

my ($rstdin, $wstdin) = portable_pipe;
my ($rstdout, $wstdout) = portable_pipe;
my ($rstderr, $wstderr) = portable_pipe;

my $cv = run_cmd([qw(cat -n)],
    '<' => $rstdin,
    '>' => $wstdout,
    '2>' => $wstderr,
);

$cv->cb(sub {
    shift->recv and die "openssl failed";
    print "FINI\n";
});

my $hdl5;
$hdl5 = new AnyEvent::Handle
    fh => $rstdout,
    on_error => sub {
	my ($hdl, $fatal, $msg) = @_;
	print STDERR "STDOUT $msg\n";
	$hdl->destroy;
    },
    on_read => sub {
	my $hdl = shift;

	$hdl->push_read(line => sub {
	    my ($hdl, $line) = @_;
	    print "STDOUT $line\n";
	});
    };

my $hdl2 = new AnyEvent::Handle
    fh => $wstdin;

my $hdl3 = new AnyEvent::Handle
    fh => \*STDIN,
    on_read => sub {
	my $hdl = shift;

	$hdl->push_read(line => sub {
	    my ($hdl, $line) = @_;
	    $hdl2->push_write("$line\n");
	    print "SENDING: $line\n";
	});
    };

#$cv->cb( sub {
#    print "WOOO\n";
#});

$q->recv;
